/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

/*
 * Created on Jan 31, 2005
 *
 */
package com.sunlabs.archsim.tests.fifo;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.gasp.Action;
import com.sunlabs.archsim.gasp.Function;
import com.sunlabs.archsim.gasp.Terminal;

import java.util.Iterator;

/**
 * @author ib27688
 *
 * Model a sink for the FIFO - take tata items and throw them away.
 */
public class FifoSink extends Action {
	
	public FifoSink(String name) {
		super(name);
		outputFunctions.put("ackDataIn", new ActionFired());
	} // FifoAction
	
	/** Vacuous function used to acknowldge that the action has fired */ 
	private class ActionFired extends Function {
		
		public ActionFired() {
			super("Vacous");
			functionDelay= new Delay(0); // was 10
		}
	
		public Object value() {
			Iterator ti= terminals.iterator();
			Terminal t= null;
			boolean done= false;
			while (!done && ti.hasNext()) {
				t= (Terminal)(ti.next());
				if (t.getBaseName() == "dataIn") {
					done= true;
				}
			}
			if (t != null && FifoGlobal.sinkDisplayReceived ) {
				director.journal("Sink received " + t.getData());
			}
			return null;
		} // value
	} // AcknowledgeData

	
} // FifoSink
